class newTCPserver:

    def __init__(self, _q_send_to_comport, _queue_to_proscan_pri):
        global status, stop

        self.SERVER_ADDRESS = (config.IP_ADDR, config.SERVER_PORT)

        #   ,      
        self.MAX_CONNECTIONS = 1

        #     
        self.INPUTS = list()
        self.OUTPUTS = list()
        self.ready_to_send = False
        self.q_send_to_comport = _q_send_to_comport
        self.queue_to_Proscan_pri = _queue_to_proscan_pri
        self.status_conn_Proscan = False
        self.send_start = False
        self.start()

    def start(self):
        import select
        server_socket = self.get_non_blocking_server_socket()
        self.INPUTS.append(server_socket)

        print("server is running, please, press ctrl+c to stop")
        try:
            while self.INPUTS:
                # rootLogger.info("here")
                readables, writables, exceptional = select.select(self.INPUTS, self.OUTPUTS, self.INPUTS)
                self.handle_readables(readables, server_socket)
                self.handle_writables(writables)
        except KeyboardInterrupt:
            self.clear_resource(server_socket)
            print("Server stopped! Thank you for using!")

    def get_non_blocking_server_socket(self):

        #  ,      
        server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        server.setblocking(0)

        #       
        server.bind(self.SERVER_ADDRESS)

        #    
        server.listen(self.MAX_CONNECTIONS)

        return server

    def handle_readables(self, readables, server):
        """
            
        """

        for resource in readables:

            #      ,     
            if resource is server:
                connection, client_address = resource.accept()
                connection.setblocking(0)
                self.INPUTS.append(connection)
                rootLogger.info("new connection from {address}".format(address=client_address))

            #       ,       
            else:
                data = ""
                try:
                    data = resource.recv(1024)

                #       
                except ConnectionResetError:
                    pass

                if data:

                    #     
                    rootLogger.info("getting data: {data}".format(data=str(data)))
                    self.data_parser(data)
                    #   ,         
                    if resource not in self.OUTPUTS:
                        self.OUTPUTS.append(resource)

                #   ,   ,            
                else:

                    #       
                    self.clear_resource(resource)

    def clear_all_resources(self):
        rootLogger.info(locals())
        for resource in self.INPUTS:
            rootLogger.info("resource closing:{}".resource)
            try:
                resource.close()
            except:
                pass

    def handle_writables(self, writables):
        # rootLogger.info(locals())
        #global status
        #          
        for resource in writables:
            try:
                if not self.send_start:
                    if self.status_conn_Proscan:
                        # resource.send(bytes('Hello from server!', encoding='UTF-8'))
                        while not self.queue_to_Proscan_pri.empty():
                            _d = self.queue_to_Proscan_pri.get()
                            data = b"STARTDAT 00229 PS30 START\r" + _d + b" ENDDAT"
                            # rootLogger.info(data)
                            resource.send(data)
                        # rootLogger.info("empty")
                        #rootLogger.info(status)
                        data = b"STARTDAT 00229 PS30 START\r" + status + b" ENDDAT"
                        resource.send(data)
                        # while not self.queue_to_Proscan_pri.empty():
                        #    data = b"STARTDAT 00229 PS30 START\r" + self.queue_to_Proscan_pri.get() + b" ENDDAT"
                        #    rootLogger.info("send to Proscan={}".format(data))
                        #    resource.send(data)
                else:
                    rootLogger.info("sending start messages")
                    resource.send(b'HTTP/1.0 200 OK\r\n\r\nUser-Agent: ProScan 10.0        \r\n\r\n')
                    resource.send(b'STARTDAT 00062 PS02,BCD396XT,VERSION=10.0,DLUL=1,AUDIO=2 ENDDAT')
                    self.send_start = False
                    self.status_conn_Proscan = True

            except OSError:
                self.clear_resource(resource)

    def data_parser(self, _data):
        if not _data: return
        command_to_send = self.commands_parser(_data)

        if command_to_send:
            rootLogger.info(" command to send {}".format(command_to_send))
            try:
                self.q_send_to_comport.put_nowait(command_to_send)
            except:
                pass

    def commands_parser(self, _data):
        if not b'STARTDAT' in _data:
            rootLogger.info("Arrive unknown command")
            return

        comm_code = str(_data).split(" ")[1]
        if '00049' in comm_code and not self.send_start:  # start message from Proscan
            self.send_start = True
        if "00034" in comm_code:  # keypress
            return "{x[3]}".format(x=str(_data).split(" "))
        if "00026" in comm_code:  # end
            rootLogger.info("End of Proscan session")
            self.status_conn_Proscan = False

        return

    def __del__(self):
        rootLogger.info(locals())
        self.clear_all_resources()

    def clear_resource(self, resource):
        """
            
        """
        if resource in self.OUTPUTS:
            self.OUTPUTS.remove(resource)
        if resource in self.INPUTS:
            self.INPUTS.remove(resource)
        resource.close()
        self.send_start = False
        with q_send_to_Proscan.mutex:
            q_send_to_Proscan.queue.clear()
        self.status_conn_Proscan = False
        rootLogger.info('closing connection ' + str(resource))
